
#define NULL 0
typedef unsigned int addr;
typedef unsigned int uint32_t;
typedef unsigned int uint16_t;

int load_imports(addr hash);

int
WinMainCRTStartup(void)
{
  addr kernel_ret = NULL;
  
  // get kernel_ret
  asm volatile(
      "movl 4(%%ebp), %%eax\n\t"
      "movl %%eax, %0"
      : "=g"(kernel_ret));

  if( load_imports(kernel_ret) != 0 )
    return 1;

  return 0;  
}

void my_strcpy(char *where, const char *what)
{
  while((*where = *what) != '\0') what++, where++;
}

void my_strcat(char *where, const char *what)
{
  while(*where != '\0') where++;
  while((*where = *what) != '\0') what++, where++;
}

int load_imports(addr hash)
{
  addr kernel32_instance = NULL;
  addr user32_instance = NULL;  
  __stdcall addr (*GetProcAddress)(addr,const char*);
  __stdcall addr (*LoadLibraryA)(const char*);  
  __stdcall addr (*MessageBoxA)(addr, const char*, const char*, uint32_t);
  char info[256];
  

  static struct {
    addr hash;
    addr loadlib;
    addr getproc;         
    const char *version;
  } *p, addr_table[] = {
    { 0x77E4F38C, 0x77E4850D, 0x77E42DFB, "5.2.3790" },
    { 0x77E7EB69, 0x77E805D8, 0x77E7A5FD, "5.1.2600" },
    { 0x77E8141A, 0x77E7D8B4, 0x77E7B285, "5.1.2600 Service Pack 1" },
    { 0x77E814C7, 0x77E7D961, 0x77E7B332, "5.1.2600 Dodatek Service Pack. 1" },
    { 0x77E87903, 0x77E98023, 0x77E9564B, "5.0.????" },
    { 0x77E962B6, 0x77E8DF64, 0x77E8D2D3, "5.1.2600" },
    { 0x77E97D08, 0x77E8A254, 0x77E89AC1, "5.0.2195 Dodatek Service Pack. 2" },
    { 0x793487F5, 0x793505CF, 0x7934E6A9, "5.0.2195 Service Pack 4" },   
    { 0x7C816D4F, 0x7C801D77, 0x7C80AC28, "5.1.2600 Dodatek Service Pack 2" },
    { 0xBFF8B537, 0xBFF776D4, 0xBFF76DAC, "4.10.1998" },
    { 0xBFF8B560, 0xBFF776D0, 0xBFF76DA8, "4.10.2222 A" },
    { NULL,       NULL,       NULL,       NULL }
  };

  /* get addresses */
  for(p = addr_table; p->hash; p++)
  {
    if(p->hash == hash)
    {
      LoadLibraryA = (void*)p->loadlib;
      GetProcAddress = (void*)p->getproc;
      break;
    }
  }

  if(p->hash == NULL)
    return -1;

  /* load lib */
  //LoadLibraryA = (void*)GetProcAddress(kernel32_instance, "LoadLibraryA");
  user32_instance = LoadLibraryA("user32.dll");
  MessageBoxA = (void*)GetProcAddress(user32_instance, "MessageBoxA");

  my_strcpy(info, "Import concealment r&d by Gynvael Coldwind of Vexillium.\n"
                  "Detected windows version ");
  my_strcat(info, p->version);

  MessageBoxA(0, info, "Import concealment", 0);  

  return 0;
}

